import type { Workspace } from './workspace';
import { Collection } from './collection';
import type { Record, TypeSpec } from '@arsonar/common';
export declare type BotConfig = any;
export declare type BotSpec = {
    name?: string;
    types: TypeSpec[];
};
export declare type BotHandlersInit = ((opts: BotHandlersInitArgs) => BotHandlers) | BotHandlers;
export declare type BotHandlersInitArgs = {
    spec: BotSpec;
    config: BotConfig;
    workspace: Workspace;
};
export interface BotHandlers {
    open?: () => Promise<void> | void;
    onjoin: (collection: Collection, config: any) => Promise<BotSession>;
    oncommand?: (command: string, args: any) => Promise<any>;
}
export interface BotSession {
    open?: () => Promise<void> | void;
    close?: () => Promise<void> | void;
    oncommand: (command: string, args: any) => Promise<any>;
    onrecord?: (record: Record) => Promise<void>;
}
export declare class Bots {
    private workspace;
    private bots;
    private log;
    private _eventSource?;
    private _init?;
    private _sessionId?;
    constructor(workspace: Workspace);
    close(): Promise<void>;
    join(botName: string, collection: string): Promise<any>;
    leave(botName: string, collection: string): Promise<any>;
    info(): Promise<any>;
    command(botName: string, command: string, args: any, env: any): Promise<any>;
    commandStatus(botName: string, requestId: string): Promise<any>;
    getCommands(): Promise<void>;
    private _initListener;
    private reply;
    private _onmessage;
    private getHeaders;
    private fetch;
    register(name: string, spec: BotSpec, handlers: BotHandlersInit): Promise<void>;
}
//# sourceMappingURL=bots.d.ts.map