"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMany = exports.createOne = void 0;
// @ts-ignore
const create_js_1 = __importDefault(require("@arsonar/server/test/lib/create.js"));
const index_js_1 = require("../../index.js");
async function createOne(opts = {}) {
    const { server, endpoint, cleanup: cleanupServer } = await create_js_1.default.createOne(opts);
    const clientOpts = opts.clientOpts || {};
    const client = new index_js_1.Workspace({ endpoint, ...clientOpts });
    return { server, cleanup, endpoint, client };
    async function cleanup() {
        await client.close();
        await cleanupServer();
    }
}
exports.createOne = createOne;
async function createMany(n, opts = {}) {
    const instances = await create_js_1.default.createMany(n, opts);
    instances.clients = instances.endpoints.map((endpoint) => {
        return new index_js_1.Workspace({ endpoint });
    });
    const cleanup = instances.cleanup;
    instances.cleanup = async function () {
        await Promise.all(instances.clients.map((client) => client.close()));
        await cleanup();
    };
    return instances;
}
exports.createMany = createMany;
exports.default = {
    createOne,
    createMany
};
//# sourceMappingURL=create.js.map